#include<stdio.h>
#include<stdlib.h>
#include<string.h>

/* (a) podzadatak */
typedef struct {
    char* naziv;
    int godina, trajanje;
    int n; /* trebamo pamtiti koliko glumaca imamo */
    char** glumci;
} film;

/* (b) podzadatak */
/* pomocna funkcija za unos stringa do znaka zadnji - kroz varijabilni
   argument vraca 1 ako naidje na '\n' (inace 0) */
char* unesi_string(char zadnji, int* krajlinije){
    scanf(" "); /* tako da preskocimo moguce '\n' i bjeline prije unosa */
    int duljina = 0;
    char* string = NULL;
    do {
        string = (char*)realloc(string,(++duljina) * sizeof(char));
        scanf("%c", &string[duljina-1]); /* ucitamo sljedeci znak */
    } while(string[duljina-1] != zadnji && string[duljina-1] != '\n');
    *krajlinije = (string[duljina-1] == '\n');
    string[duljina-1] = '\0'; /* zadnji ucitani znak zamijenimo s '\0' */
    return string;
}

film* novi(void){
    film* nov = (film*)malloc(sizeof(film));
    int krajlinije;
    nov->naziv = unesi_string('(',&krajlinije);
    scanf("%d, %d) - ", &(nov->godina), &(nov->trajanje));
    nov->n = 0;
    nov->glumci = NULL;
    while(krajlinije == 0){
        nov->glumci = (char**)realloc(nov->glumci,(++(nov->n)) * sizeof(char*));
        nov->glumci[nov->n - 1] = unesi_string(',',&krajlinije);
    }
    return nov;
}

/* (c) podzadatak */
/* pomocna funkcija za broj zajednickih glumaca za dani film
   i niz od n glumaca glumci */
int br_zajednickih(film a, char** glumci, int n){
    int brojac = 0, i, j;
    for(i = 0; i < n; ++i)
        for(j = 0; j < a.n; ++j)
            if(strcmp(glumci[i],a.glumci[j]) == 0)
                brojac++;
    return brojac;
}

film* najbolji(film* filmovi, int m, char** glumci, int n){
    int i, max_zaj = 0;
    film* trazeni = NULL;
    for(i = 0; i < m; ++i){
        int br_zaj = br_zajednickih(filmovi[i],glumci,n);
        if(br_zaj > max_zaj ||
           (br_zaj == max_zaj && br_zaj > 0 && filmovi[i].godina < trazeni->godina)){
                /* uvjet br_zaj > 0 jer nam ne treba slucaj kad oba br_zaj i max_zaj jednaki 0 */
                max_zaj = br_zaj;
                trazeni = &filmovi[i]; /* ili: trazeni = filmovi + i; */
        }
    }
    return trazeni;
}


/* (d) podzadatak */
/* prvo funkcija koja ce biti komparator za fju qsort */
int qkomparator(const void* a, const void* b){
    film* prvi  = (film*)a;
    film* drugi = (film*)b;
    if(strcasecmp(prvi->naziv,drugi->naziv) != 0)
        return strcasecmp(prvi->naziv,drugi->naziv);
    /* else */
    return prvi->godina - drugi->godina;
}

void sortiraj(film* filmovi, int n){
    qsort(filmovi,n,sizeof(film),qkomparator);
}

/* (e) podzadatak */
int bkomparator(const void* a, const void* b){
    film* prvi  = (film*)a;
    film* drugi = (film*)b;
    return strcasecmp(prvi->naziv,drugi->naziv);
}

int postoji(film* filmovi, int n, char* naziv){
    film temp;
    temp.naziv = naziv;
    if(bsearch(&temp,filmovi,n,sizeof(film),bkomparator) == NULL)
        return 0;
    /* else */
    return 1;
}


/* ----------------------------------------------------------- */
/* -------------------- DIO ZA TESTIRANJE -------------------- */
/* ----------------------------------------------------------- */

/* pomocna funkcija za ispis podataka o filmu na koji pokazuje a */
void ispis(film* a){
    printf("\tNaziv:    %s\n", a->naziv);
    printf("\tGodina:   %d\n", a->godina);
    printf("\tTrajanje: %d\n", a->trajanje);
    printf("\tGlumci:\n");
    int j;
    for(j = 0; j < a->n; ++j)
        printf("\t\t%s\n", a->glumci[j]);
    printf("\n"); /* zbog preglednosti */
}

int main(void){
    int n, i, j;
    printf("Za koliko filmova unosite podatke: ");
    scanf("%d", &n);

    film* filmovi = (film*)malloc(n * sizeof(film));

    for(i = 0; i < n; ++i){
        film* nov = novi();
        filmovi[i] = *nov; /* iskopiramo dijelove */
        free(nov); /* nov nam vise ne treba jer iskopirali dijelove */
    }

    /* ispis svih unesenih podataka radi testiranja */
    printf("---------- Uneseni podaci: ----------\n");
    for(i = 0; i < n; ++i){
        printf("Ispis podataka o %d. filmu:\n", i + 1);
        ispis(filmovi + i); /* ili: ispis(&filmovi[i]); */
    }
    printf("-------------------------------------\n");

    /* unos imena glumaca u polje glumci */
    int m;
    printf("Unesite broj glumaca za \"najbolji film\": ");
    scanf("%d", &m);

    printf("Unesite imena %d glumaca (svako u novi red):\n", m);
    char** glumci = (char**)malloc(m * sizeof(char*));
    int krajlinije;
    for(i = 0; i < m; ++i)
        glumci[i] = unesi_string('\n',&krajlinije);

    /* testni ispis za unesene glumce: */
    printf("---------- Uneseni glumci: ----------\n");
    for(i = 0; i < m; ++i)
        printf("\t%s\n", glumci[i]);
    printf("\n"); /* radi preglednosti */


    /* poziv funkcije iz (c) podzadatka i ispis podatka o "najboljem filmu" */
    film* naj = najbolji(filmovi, n, glumci, m);
    printf("Najbolji film:\n");
    if(naj == NULL)
        printf("\tNe postoji :(\n");
    else
        ispis(naj);

    /* testiranje funkcije za sortiranje iz (d) podzadatka */
    sortiraj(filmovi,n);
    printf("--------- Sortirani podaci: ---------\n");
    for(i = 0; i < n; ++i){
        printf("Ispis podataka o %d. filmu:\n", i + 1);
        ispis(filmovi + i); /* ili: ispis(&filmovi[i]); */
    }
    printf("-------------------------------------\n");


    /* testiranje funkcije za trazenje iz (e) podzadatka */
    printf("Naziv filma koji trazimo: ");
    char* trazeni = unesi_string('\n',&krajlinije);
    printf("Film s tim nazivom %spostoji.", (postoji(filmovi,n,trazeni)) ? "" : "ne ");


    /* dealokacija */
    /* dealokacija stringova u svakom filmu i onda polja filmova */
    for(i = 0; i < n; ++i){
        free(filmovi[i].naziv);
        for(j = 0; j < filmovi[i].n; ++j)
            free(filmovi[i].glumci[j]);
        free(filmovi[i].glumci);
    }
    free(filmovi);
    /* dealokacija polja glumaca */
    for(i = 0; i < m; ++i)
        free(glumci[i]);
    free(glumci);
    /* dealokacija naziva filma koji smo trazili */
    free(trazeni);

    return 0;
}


/* Primjer podataka o filmovima (za n = 7 filmova):
    The Ring(2002, 115) - Naomi Watts, Martin Henderson, David Dorfman, Brian Cox, Daveigh Chase
    Hotel Grand Budapest(2014, 99) - Jeff GoldBlum, Bill MurRay, Jude Law, Willem DaFoe
    Jurrassic Park(1993, 127) - Sam Neill, Laura Dern, Jeff Goldblum
    Panika pod morem(2004, 119) - Bill Murray, Owen Wilson, Cate Blanchet, Willem Dafoe, Jeff GoldBlum
    Paw Patrol(2020, 66) - Julius Cho, Anya Cooke, Cal Dodd, Addison Holley
    Paw Patrol(2019, 66) - Julius Cho, Anya Cooke, Cal Dodd, Addison Holley
    Spider-Man(2002, 121) - Tobey Maguire, Willem Dafoe, Kirsten Dunst, James Franco

   Primjer podataka za polje (za m = 3 glumca):
    Bill Murray
    Anya Cooke
    Jeff Goldblum
*/
