#include<stdio.h>
#include<stdlib.h>
#include<string.h>

/* (a) podzadatak */
typedef struct {
    char* ime;
    int oscari, godina;
    int n; /* trebamo pamtiti koliko filmova imamo */
    char** filmovi;
} glumac;

/* (b) podzadatak */
/* pomocna funkcija za unos stringa do znaka zadnji - kroz varijabilni
   argument vraca 1 ako naidje na '\n' (inace 0) */
char* unesi_string(char zadnji, int* krajlinije){
    scanf(" "); /* tako da preskocimo moguce '\n' i bjeline prije unosa */
    int duljina = 0;
    char* string = NULL;
    do {
        string = (char*)realloc(string,(++duljina) * sizeof(char));
        scanf("%c", &string[duljina-1]); /* ucitamo sljedeci znak */
    } while(string[duljina-1] != zadnji && string[duljina-1] != '\n');
    *krajlinije = (string[duljina-1] == '\n');
    string[duljina-1] = '\0'; /* zadnji ucitani znak zamijenimo s '\0' */
    return string;
}

glumac* unesi(void){
    glumac* novi = (glumac*)malloc(sizeof(glumac));
    int krajlinije;
    novi->ime = unesi_string('[',&krajlinije);
    scanf("%d; %d]: ", &(novi->oscari), &(novi->godina));
    novi->n = 0;
    novi->filmovi = NULL;
    while(krajlinije == 0){
        novi->filmovi = (char**)realloc(novi->filmovi,(++(novi->n)) * sizeof(char*));
        novi->filmovi[novi->n - 1] = unesi_string(',',&krajlinije);
    }
    return novi;
}

/* (c) podzadatak */
/* pomocna funkcija za broj zajednickih filmova za danog glumca i niz od m filmova filmovi */
int br_zajednickih(glumac g, char** filmovi, int m){
    int brojac = 0, i, j;
    for(i = 0; i < m; ++i)
        for(j = 0; j < g.n; ++j)
            if(strcmp(filmovi[i],g.filmovi[j]) == 0)
                brojac++;
    return brojac;
}

glumac* naj(glumac* glumci, int n, char** filmovi, int m){
    int i, max_zaj = 0;
    glumac* trazeni = NULL;
    for(i = 0; i < n; ++i){
        int br_zaj = br_zajednickih(glumci[i],filmovi,m);
        if(br_zaj > max_zaj ||
           (br_zaj == max_zaj && br_zaj > 0 && glumci[i].oscari > trazeni->oscari)){
                /* uvjet br_zaj > 0 jer nam ne treba slucaj kad oba br_zaj i max_zaj jednaki 0 */
                max_zaj = br_zaj;
                trazeni = &glumci[i]; /* ili: trazeni = glumci + i; */
        }
    }
    return trazeni;
}

/* (d) podzadatak */
/* prvo funkcija koja ce biti komparator za fju qsort */
int qkomparator(const void* a, const void* b){
    glumac* prvi  = (glumac*)a;
    glumac* drugi = (glumac*)b;
    if(strcasecmp(prvi->ime,drugi->ime) != 0)
        return strcasecmp(prvi->ime,drugi->ime);
    /* else */
    return prvi->oscari - drugi->oscari;
}

void poslozi(glumac* glumci, int m){
    qsort(glumci,m,sizeof(glumac),qkomparator);
}


/* (e) podzadatak */
/* prvo funkcija koja ce biti komparator za fju bsearch */
int bkomparator(const void* a, const void* b){
    glumac* prvi  = (glumac*)a;
    glumac* drugi = (glumac*)b;
    return strcasecmp(prvi->ime,drugi->ime);
}

int trazi(glumac* glumci, int m, char* ime){
    glumac temp;
    temp.ime = ime;
    if(bsearch(&temp,glumci,m,sizeof(glumac),bkomparator) == NULL)
        return 0;
    /* else */
    return 1;
}


/* ----------------------------------------------------------- */
/* -------------------- DIO ZA TESTIRANJE -------------------- */
/* ----------------------------------------------------------- */

/* pomocna funkcija za ispis podataka o glumcu na koji pokazuje a */
void ispis(glumac* a){
    printf("\tIme:             %s\n", a->ime);
    printf("\tBroj Oscara:     %d\n", a->oscari);
    printf("\tGodina rodjenja: %d\n", a->godina);
    printf("\tPopis filmova:\n");
    int j;
    for(j = 0; j < a->n; ++j)
        printf("\t\t%s\n", a->filmovi[j]);
    printf("\n"); /* zbog preglednosti */
}

int main(void){
    int n, i, j;
    printf("Za koliko glumaca unosite podatke: ");
    scanf("%d", &n);

    glumac* glumci = (glumac*)malloc(n * sizeof(glumac));

    for(i = 0; i < n; ++i){
        glumac* nov = unesi();
        glumci[i] = *nov; /* iskopiramo dijelove */
        free(nov); /* nov nam vise ne treba jer iskopirali dijelove */
    }

    /* ispis svih unesenih podataka radi testiranja */
    printf("---------- Uneseni podaci: ----------\n");
    for(i = 0; i < n; ++i){
        printf("Ispis podataka o %d. glumcu:\n", i + 1);
        ispis(glumci + i); /* ili: ispis(&glumci[i]); */
    }
    printf("-------------------------------------\n");

    /* unos naziva filmova u polje filmovi */
    int m;
    printf("Unesite broj filmova za \"naj glumca\": ");
    scanf("%d", &m);

    printf("Unesite nazive %d filmova (svaki u novi red):\n", m);
    char** filmovi = (char**)malloc(m * sizeof(char*));
    int krajlinije;
    for(i = 0; i < m; ++i)
        filmovi[i] = unesi_string('\n',&krajlinije);

    /* testni ispis za unesene filmove: */
    printf("---------- Uneseni filmovi: ----------\n");
    for(i = 0; i < m; ++i)
        printf("\t%s\n", filmovi[i]);
    printf("\n"); /* radi preglednosti */


    /* poziv funkcije iz (c) podzadatka i ispis podatka o "naj glumcu" */
    glumac* najgl = naj(glumci, n, filmovi, m);
    printf("Naj glumac:\n");
    if(najgl == NULL)
        printf("\tNe postoji :(\n");
    else
        ispis(najgl);

    /* prvo testiranje funkcije za sortiranje iz (e) podzadatka
       (jer za binarno pretrazivanje trebamo sortirani niz) */
    poslozi(glumci,n);
    printf("--------- Sortirani podaci: ---------\n");
    for(i = 0; i < n; ++i){
        printf("Ispis podataka o %d. glumcu:\n", i + 1);
        ispis(glumci + i); /* ili: ispis(&glumci[i]); */
    }
    printf("-------------------------------------\n");


    /* testiranje funkcije za trazenje iz (d) podzadatka */
    printf("Ime glumca kojeg trazimo: ");
    char* trazeni = unesi_string('\n',&krajlinije);
    printf("Glumac s tim imenom %spostoji.", (trazi(glumci,n,trazeni)) ? "" : "ne ");


    /* dealokacija */
    /* dealokacija stringova u svakom glumcu i onda polja glumaca */
    for(i = 0; i < n; ++i){
        free(glumci[i].ime);
        for(j = 0; j < glumci[i].n; ++j)
            free(glumci[i].filmovi[j]);
        free(glumci[i].filmovi);
    }
    free(glumci);
    /* dealokacija polja s nazivima filmova */
    for(i = 0; i < m; ++i)
        free(filmovi[i]);
    free(filmovi);
    /* dealokacija imena glumca kojeg smo trazili */
    free(trazeni);

    return 0;
}


/* Primjer podataka o glumcima (za n = 7 glumaca):
    Antony Hopkins[1; 1937]: Armageddon Time, The Silence of the Lambs, Thor: Ragnarok, Heartburn
    Meryl Streep[3; 1949]: Heartburn, Into the Woods, Mamma Mia!, Fantastic Mr. Fox
    Jodie Foster[2; 1962]: The Silence of the Lambs, The Accused
    Robert De Niro[2; 1943]: Armageddon Time, Joker, Little Fockers, The Deer Hunter
    Jodie Foster[1; 1962]: The Silence of the Lambs, The Accused
    Cate Blanchett[2; 1969]: The Lord of the Rings, Armageddon Time, Thor: Ragnarok, The Hobbit
    Jack Nicholson[3; 1937]: The Shining, Mars Attacks!, Wolf, A Few Good Men, Hoffa

   Primjer podataka za polje (za m = 3 filma):
    the simpsons
    armageddon time
    thor: ragnarok
*/
