#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct _kolegij{
    char naziv[31];
    int sifra;
    int br_prethodnika;
    int *prethodnici;
    int godina;
    char semestar;
    struct _kolegij *next;
}kolegij;

kolegij* unesi(kolegij *novi, kolegij* first){
    novi->next = first;
    return novi;
}

kolegij* azuriraj(kolegij *novi, int sljedbenici[], int br_sljedbenika, kolegij* first){
    int i;
    kolegij *pom;

    /*ako je kolegij sa iste godine i semestra, samo ga dodaj u listu*/
    if((novi->godina == first->godina && novi->semestar == first->semestar)||first==NULL){
        novi->next = first;
        return novi;
    }

    /*ako se radi o nekoj drugoj godini ili semestru, moramo provjeriti treba li ažurirati listu prethodnika*/

    for(pom = first; pom; pom = pom->next){
        for(i = 0; i<br_sljedbenika; i++){
            if(pom->sifra == sljedbenici[i]){
                pom->br_prethodnika++;
                pom->prethodnici = (int*)realloc(pom->prethodnici,pom->br_prethodnika*sizeof(int));
                pom->prethodnici[pom->br_prethodnika-1] = novi->sifra;
            }
        }
    }

    return first;

}

kolegij* sort(kolegij* first, int polozeni[], int br_polozenih){
    kolegij* pom1, *preth1=NULL, *pom2, *preth2=NULL;
    pom1 = first;

    int i,j,podudaranja1, podudaranja2;

    while(pom1){
        podudaranja1 = 0;
        for(i=0; i<pom1->br_prethodnika; i++){
            for(j=0; j< br_polozenih; j++){
                if(pom1->prethodnici[i] == polozeni[j]){
                    podudaranja1++;
                    break;
                }
            }
        }

        pom2 = pom1->next;
        preth2 = pom1;
        while(pom2){
            podudaranja2 = 0;
            for(i=0; i<pom2->br_prethodnika; i++){
                for(j=0; j< br_polozenih; j++){
                    if(pom2->prethodnici[i] == polozeni[j]){
                        podudaranja2++;
                        break;
                    }
                }
            }

            if((pom1->br_prethodnika - podudaranja1)>(pom2->br_prethodnika-podudaranja2)){
                if(preth1) preth1->next = pom2;
                if(preth2) preth2->next = pom1;

                kolegij* temp = pom1->next;
                pom1->next = pom2->next;
                pom2->next = temp;

                if(preth1 == NULL) first = pom2;
            }
            preth2 = pom2;
            pom2 = pom2->next;
        }
        preth1 = pom1;
        pom1 = pom1->next;
    }
    return first;
}

kolegij* upisani(kolegij** semestar, int polozeni[], int br_polozenih){
    kolegij *first_upisani = NULL, *last_upisani, *first_ostali = NULL, *last_ostali = NULL, *iter = *semestar;

    int i, j, podudaranja;
    while(iter){
        podudaranja = 0;
        for(i=0; i<iter->br_prethodnika; i++){
            for(j=0; j< br_polozenih; j++){
                if(iter->prethodnici[i] == polozeni[j]){
                    podudaranja++;
                    break;
                }
            }
        }
        if(podudaranja == iter->br_prethodnika){
            if(first_upisani) last_upisani = last_upisani->next = iter;
            else last_upisani = first_upisani = iter;
            iter = iter->next;
        }
        else{
            if(first_ostali) last_ostali = last_ostali->next = iter;
            else last_ostali = first_ostali = iter;
            iter = iter->next;
        }
    }

    if(first_upisani) last_upisani->next = NULL;
    if(first_ostali) last_ostali->next = NULL;

    first_ostali = sort(first_ostali, polozeni, br_polozenih);

    *semestar = first_ostali;

    return first_upisani;
}

void ispisi(kolegij* first){
    int i;
    while(first){
        printf("Naziv kolegija: %s\n", first->naziv);
        printf("Sifra kolegija: %d\n", first->sifra);
        printf("Kolgiji prethodnici: ");
        for(i=0; i<first->br_prethodnika; i++){
            printf(" %d ", first->prethodnici[i]);
        }
        printf("\nGodina: % d\n", first->godina);
        printf("Semestar: %c\n", first->semestar);
        first = first->next;
    }
}

int main()
{
    kolegij *lista1 = NULL;
    kolegij *ostali = NULL;
    char naziv[3][31] = {"MA1", "EM1", "LA1"};
    int sifra[3] = {1234, 2341, 3412};
    int br_prethodnika[3] = {0};
    int godina[3] = {1,1,1};
    char semestar[3] = {'Z', 'Z', 'Z'};

    int n=3, i;

    for(i=0; i<n; i++){
        kolegij* temp = (kolegij*)malloc(sizeof(kolegij));
        strcpy(temp->naziv, naziv[i]);
        temp->sifra = sifra[i];
        temp->br_prethodnika = br_prethodnika[i];
        temp->prethodnici = NULL;
        temp->godina = godina[i];
        temp->semestar = semestar[i];
        lista1 = unesi(temp, lista1);
    }

    printf("1. godina\n");
    ispisi(lista1);

    kolegij *lista2 = NULL;
    char naziv2[4][31] = {"MA2", "EM2", "LA2", "PROG2"};
    int sifra2[4] = {5678, 6785, 7856, 8567};
    int br_prethodnika2[4] = {1,0,2,0};
    int godina2[4] = {1,1,1,1};
    char semestar2[4] = {'L', 'L', 'L', 'L'};

    n=4;

    for(i=0; i<n; i++){
        kolegij* temp = (kolegij*)malloc(sizeof(kolegij));
        strcpy(temp->naziv, naziv2[i]);
        temp->sifra = sifra2[i];
        temp->br_prethodnika = br_prethodnika2[i];
        temp->prethodnici = NULL;
        if(strcmp(naziv2[i],"MA2")==0){
            temp->prethodnici = (int*)malloc(sizeof(int));
            temp->prethodnici[0] = 1234;
        }
        if(strcmp(naziv2[i],"LA2")==0){
            temp->prethodnici = (int*)malloc(2*sizeof(int));
            temp->prethodnici[0] = 2341;
            temp->prethodnici[1] = 3412;
        }
        temp->godina = godina2[i];
        temp->semestar = semestar2[i];
        lista2 = unesi(temp, lista2);
    }

    printf("\n");
    printf("2. godina:\n");
    ispisi(lista2);

    /*Dodajem PROG1*/
    kolegij* temp = (kolegij*)malloc(sizeof(kolegij));
    strcpy(temp->naziv, "PROG1");
    temp->sifra = 4123;
    temp->br_prethodnika = 0;
    temp->prethodnici = NULL;
    temp->godina = 1;
    temp->semestar = 'Z';

    int sljedbenici[1] = {8567};

    lista1 = azuriraj(temp, sljedbenici, 1, lista1);
    printf("\n Azurirana 1. godina: \n");
    ispisi(lista1);

    lista2 = azuriraj(temp, sljedbenici, 1, lista2);
    printf("\n Azurirana 2. godina: \n");
    ispisi(lista2);

    int polozeni[2] = {4123, 2341};
    ostali = upisani(&lista2, polozeni, 2);

    printf("\nOstali predmeti: \n");
    ispisi(lista2);

    printf("\nUpisani predmeti: \n");
    ispisi(ostali);

    return 0;
}
